/* This simple animation demo won't work on the Oct. 1990
   Win32S release due to some floating point problems
   (at least w/o a coprocessor) */
#include "vwinl.h"
#include <math.h>

#define NRMAPS 16
VMAP *map[NRMAPS];

long usr_cb(HWND hWnd, UINT Message,
            UINT wParam, LONG lParam)
  {
  static int timer_id;
  static int mapnr=0;
  switch (Message)
    {
     HDC dc;
     int i;
     case WM_VCREATE:
/* Compute image for each "tick" around the circle */
         for (i=0;i<NRMAPS;i++)
           {
           float f;
           int x,y;
           map[i]=Vcreate_map(200,200);
           dc=map[i]->dc;
           Ellipse(dc,10,10,190,190);
/* 6.282=2*pi (360 deg. in radians) */
           f=(6.282/NRMAPS)*i;
           x=cos(f)*50.0+100;
           y=sin(f)*50.0+100;
           Ellipse(dc,x-10,y-10,x+10,y+10);
           }
/* Kill original map */
         Vdestroy_map(Vselect_map(hWnd,map[0]));
         timer_id=SetTimer(hWnd,1,750,NULL);
     break;

     case WM_COMMAND:
            switch (LOWORD(wParam))
              {

              case 101:
                MessageBox(hWnd,
                "VWIN Test Program by Al Williams",
                "About MAIN5",MB_OK);
                break;

              case 102:
                PostMessage(hWnd,WM_DESTROY,0,0);
                break;
              }
            break;

     case WM_TIMER:
/* Pick next image on each timer tick */
            if (++mapnr==NRMAPS) mapnr=0;
            Vselect_map(hWnd,map[mapnr]);
            return 0;

     case WM_DESTROY:
/* Deselect all maps */
            Vselect_map(hWnd,NULL);
            KillTimer(hWnd,timer_id);
/* Kill all maps */
            for (i=0;i<NRMAPS;i++)
              Vdestroy_map(map[i]);
            break;
    }
  return DefWindowProc(hWnd,Message,wParam,lParam);
  }

int main(HANDLE hInstance, HANDLE hPrevInstance,
                   LPSTR lpszCmdLine, int nCmdShow )
   {
   HWND hWnd;
   if (Vcreate_window("Test Program #5",
                        WS_HSCROLL|WS_VSCROLL|
                        WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,0,
                        CW_USEDEFAULT,0,NULL,"mainmenu",
                        usr_cb,V_AUTOHSCROLL|V_AUTOVSCROLL,
                        NULL,&hWnd,nCmdShow))
      {
      MessageBox(NULL,"Can't open window",NULL,MB_OK);
      return 0;
      }
   return 1;
   }
