/* Header for VWINL -- Williams */
#ifndef _VWINL_H
#define _VWINL_H
#include <windows.h>

#ifndef WIN32
#define APIENTRY FAR PASCAL
/* Check for message cracker definition
   if 1 is there assume they all are */
#ifndef GET_WM_VSCROLL_CODE
#define GET_WM_VSCROLL_CODE(w,l) (w)
#define GET_WM_HSCROLL_CODE(w,l) (w)
#define GET_WM_VSCROLL_HWND(w,l) ((HWND)HIWORD(l))
#define GET_WM_HSCROLL_HWND(w,l) ((HWND)HIWORD(l))
#define GET_WM_VSCROLL_POS(w,l)  (LOWORD(l))
#define GET_WM_HSCROLL_POS(w,l)  (LOWORD(l))
#endif

#endif /* End of non-WIN32 definitions */

/* Flags */

/* V_SCALE doesn't make sense with V_RESIZE, V_AUTOHSCROLL, or
   V_AUTOVSCROLL. V_RESIZE, doesn't make sense with any of the
   AUTOXSCROLL flags. V_NOMAP is only valid during window
   creation. V_INIT is reserved for internal use. */

#define V_SCALE 1L
#define V_RESIZE 2L
#define V_AUTOHSCROLL 4L
#define V_AUTOVSCROLL 8L
#define V_NOMAP 0x10L
#define V_NOQUIT 0x20L
#define V_NOFREEMAP 0x40L
#define V_KSCROLL 0x80L
#define V_INIT 0x80000000L

/* Flags for Vset_flags() */
#define VF_STO 0
#define VF_SET 1
#define VF_CLR 2
#define VF_TOG 3

#define WM_VCREATE WM_USER
#define Vcommit_draw(w) InvalidateRect(w,NULL,FALSE)
/* Get VMAP dc */
#define Vget_mdc(m) ((m)->dc)
#define Vget_stretchmode(m) ((m)->stretch_mode)
#define Vclear_win(w) Vclear_map(Vget_map(w))

long APIENTRY VWndProc (HWND, UINT, UINT, LONG) ;
int main(HANDLE hInstance, HANDLE hPrevInstance,
                   LPSTR lpszCmdLine, int nCmdShow );

typedef struct
  {
  HBITMAP bitmap;
  HDC dc;
  HBITMAP defbitmap;
  int xstep,ystep,xpage,ypage;
  unsigned refct;
  int stretch_mode;
  } VMAP;


typedef struct
  {
  VMAP *map;
/* dimensions of bitmap (not window) */
  unsigned int width;
  unsigned int height;
/* flags */
  unsigned long flags;
/* display offset */
  unsigned int xoff;
  unsigned int yoff;
  long (*cb)(HWND,UINT,UINT,LONG);
  } MEMWINFO;


void Vget_info(HWND w,MEMWINFO *info);
VMAP *Vget_map(HWND w);
VMAP *Vcreate_map(int wid,int hi);
void Vdestroy_map(VMAP *map);
VMAP *Vselect_map(HWND w,VMAP *new);
unsigned long Vset_flags(HWND w,unsigned long flags,int cmd);
void Vset_offset(HWND w,int x,int y);
void Vget_offset(HWND w,int *x,int *y);
int Vcreate_window(char *title,DWORD style,int x,int y,
      int wid,int hi,HWND parent,LPCSTR menu,
      long (*cb)(HWND,UINT,UINT,LONG),
      unsigned long vflags,HDC *dc,HWND *win,int show);
HDC Vget_vdc(HWND w);
int Vresize_winmap(HWND w,int wid,int hi);
int Vresize_map(VMAP *m,int wid,int hi);
void Vdont_quit(void);
void Vset_scroll(VMAP *m,int xstp,int ystp,int xpg,int ypg);
void Vclear_map(VMAP *m);
int Vset_stretchmode(VMAP *m,int mode);
int Vset_monomode(int mode);

#ifndef __BORLANDC__
#define main vwin_main
int vwin_main(HANDLE,HANDLE,LPSTR,int);
#else
int main(HANDLE,HANDLE,LPSTR,int);
#endif

#endif





